/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package library;

import java.sql.SQLException;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 *
 * @author Agnieszka
 */
public class BookFieldPattern extends javax.swing.JFrame {

    public boolean add = false, delete = false, edit = false, search = false, update = false;
    public Book b;
    private Database d = new Database();

    public BookFieldPattern() {
        initComponents();
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        Validation verify = new Validation();
        year.setInputVerifier(verify);
        ISBN.setInputVerifier(verify);

    }

    public BookFieldPattern(boolean required, Book... b) {
        initComponents();
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        Validation verify;
        if (required) {
            verify = new Validation(true);
        } else {
            verify = new Validation();
        }
        bookTitle.setInputVerifier(verify);
        authorName.setInputVerifier(verify);
        authorSurname.setInputVerifier(verify);
        year.setInputVerifier(verify);
        ISBN.setInputVerifier(verify);
        publishing.setInputVerifier(verify);
        try {
            if (b[0].getId() >= 0) {
                fillField(b[0]);
                update = true;
            }
        } catch (ArrayIndexOutOfBoundsException e) {
            //when only one parameter is defined
        }
    }

    public void fillField(Book b) {
        idValue.setText(Integer.toString(b.getId()));
        bookTitle.setText(b.getName());
        authorName.setText(b.getAuthorName());
        authorSurname.setText(b.getAuthorSurname());
        publishing.setText(b.getPublishing());
        year.setText(Integer.toString(b.getYear()));
        ISBN.setText(b.getISBN());
        Category.setSelectedItem(b.getCategory());
    }

    public void search(Book b, String... mode) {
        try {
            List<Book> books = new LinkedList<>();
            books = d.selectBooks(b);
            Object[][] data = d.convertToTable(books);
            String[] columnNames = {"ID",
                "Tytuł",
                "Imię Autora",
                "Nazwisko Autora",
                "Rok",
                "ISBN",
                "Wydawnictwo",
                "Kategoria"};
            ListResult table = new ListResult(data, columnNames, "book");
            table.setVisible(true);
            if (mode[0].equals("edit")) {
                table.setEnabledButton("edit");
            }
            if (mode[0].equals("delete")) {
                table.setEnabledButton("delete");
            }
        } catch (IndexOutOfBoundsException e) {
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        Title = new javax.swing.JLabel();
        bookTitle = new javax.swing.JTextField();
        authorname = new javax.swing.JLabel();
        authorName = new javax.swing.JTextField();
        authorSurname = new javax.swing.JTextField();
        authorsurname = new javax.swing.JLabel();
        lpublishing = new javax.swing.JLabel();
        publishing = new javax.swing.JTextField();
        lyear = new javax.swing.JLabel();
        year = new javax.swing.JTextField();
        lISBN = new javax.swing.JLabel();
        ISBN = new javax.swing.JTextField();
        lcategory = new javax.swing.JLabel();
        Category = new javax.swing.JComboBox<>();
        mainlabel = new javax.swing.JLabel();
        SaveChanges = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        idValue = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        Title.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        Title.setText("Tytuł:");

        bookTitle.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

        authorname.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        authorname.setText("Imię autora:");

        authorName.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

        authorSurname.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

        authorsurname.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        authorsurname.setText("Nazwisko autora:");

        lpublishing.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        lpublishing.setText("Wydawnictwo:");

        publishing.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

        lyear.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        lyear.setText("Rok wydania:");

        year.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        year.setName("year"); // NOI18N

        lISBN.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        lISBN.setText("ISBN:");

        ISBN.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        ISBN.setToolTipText("XXX-X-XXXX-X");
        ISBN.setName("isbn"); // NOI18N
        ISBN.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                ISBNFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                ISBNFocusLost(evt);
            }
        });

        lcategory.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        lcategory.setText("Kategoria:");

        Category.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { " ", "Przygodowe", "Naukowe", "Powieść", "Poezja", "Kryminał", "Dla dzieci", "Psychologiczne", "Podręczniki" }));
        Category.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CategoryActionPerformed(evt);
            }
        });

        mainlabel.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        mainlabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        mainlabel.setText("Wypełnij formualrz:");

        SaveChanges.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        SaveChanges.setText("OK");
        SaveChanges.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SaveChangesActionPerformed(evt);
            }
        });

        jLabel1.setLabelFor(ISBN);
        jLabel1.setText("XXX-X-XXXX-X");
        jLabel1.setToolTipText("");
        jLabel1.setDoubleBuffered(true);
        jLabel1.setName(""); // NOI18N

        idValue.setText(".");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(lcategory, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lISBN, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lyear, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(authorsurname, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lpublishing, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(authorSurname)
                            .addComponent(year, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(publishing)
                            .addComponent(ISBN)
                            .addComponent(Category, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(SaveChanges, javax.swing.GroupLayout.PREFERRED_SIZE, 220, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(jLabel1)
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(Title)
                                    .addComponent(authorname))
                                .addGap(35, 35, 35)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(authorName, javax.swing.GroupLayout.PREFERRED_SIZE, 220, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(bookTitle, javax.swing.GroupLayout.PREFERRED_SIZE, 363, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(idValue, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(mainlabel, javax.swing.GroupLayout.PREFERRED_SIZE, 289, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(0, 20, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(mainlabel)
                    .addComponent(idValue))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Title)
                    .addComponent(bookTitle, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(authorname)
                    .addComponent(authorName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(authorsurname)
                    .addComponent(authorSurname, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lpublishing)
                    .addComponent(publishing, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lyear)
                    .addComponent(year, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lISBN)
                    .addComponent(ISBN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lcategory)
                    .addComponent(Category, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(SaveChanges)
                .addContainerGap(33, Short.MAX_VALUE))
        );

        jLabel1.setVisible(false);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void CategoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CategoryActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_CategoryActionPerformed

    public void ChangeOkButtonText(String s) {
        this.SaveChanges.setText(s);
    }


    private void SaveChangesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveChangesActionPerformed
        if (this.add) {
            try {
                Book b = new Book(0, bookTitle.getText(), authorName.getText(), authorSurname.getText(), year.getText(), ISBN.getText(), publishing.getText(), Category.getSelectedItem().toString());
                b.insertToDB();
            } catch (SQLException e) {
                e.getMessage();
            }
        } else if (this.edit) {
            Book b = new Book(0, bookTitle.getText(), authorName.getText(), authorSurname.getText(), year.getText(), ISBN.getText(), publishing.getText(), Category.getSelectedItem().toString());
            this.search(b, "edit");
        } else if (this.delete) {
            Book b = new Book(0, bookTitle.getText(), authorName.getText(), authorSurname.getText(), year.getText(), ISBN.getText(), publishing.getText(), Category.getSelectedItem().toString());
            this.search(b, "delete");
        } else if (this.search) {
            Book b = new Book(0, bookTitle.getText(), authorName.getText(), authorSurname.getText(), year.getText(), ISBN.getText(), publishing.getText(), Category.getSelectedItem().toString());
            this.search(b);
        } else if (this.update) {
            try {
                Book b = new Book(Integer.parseInt(idValue.getText()), bookTitle.getText(), authorName.getText(), authorSurname.getText(), year.getText(), ISBN.getText(), publishing.getText(), Category.getSelectedItem().toString());
                b.editInDB();
            } catch (SQLException e) {
                e.printStackTrace();
            }

        }
        d.closeConnection();
        dispose();
    }//GEN-LAST:event_SaveChangesActionPerformed

    private void ISBNFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ISBNFocusGained
        jLabel1.setVisible(true);
    }//GEN-LAST:event_ISBNFocusGained

    private void ISBNFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ISBNFocusLost
        jLabel1.setVisible(false);
    }//GEN-LAST:event_ISBNFocusLost

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;

                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(BookFieldPattern.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);

        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(BookFieldPattern.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);

        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(BookFieldPattern.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);

        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(BookFieldPattern.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new BookFieldPattern().setVisible(false);
            }
        });

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> Category;
    private javax.swing.JTextField ISBN;
    private javax.swing.JButton SaveChanges;
    private javax.swing.JLabel Title;
    private javax.swing.JTextField authorName;
    private javax.swing.JTextField authorSurname;
    private javax.swing.JLabel authorname;
    private javax.swing.JLabel authorsurname;
    javax.swing.JTextField bookTitle;
    private javax.swing.JLabel idValue;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel lISBN;
    private javax.swing.JLabel lcategory;
    private javax.swing.JLabel lpublishing;
    private javax.swing.JLabel lyear;
    private javax.swing.JLabel mainlabel;
    private javax.swing.JTextField publishing;
    private javax.swing.JTextField year;
    // End of variables declaration//GEN-END:variables
}
