/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package library;

import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 *
 * @author Agnieszka
 */
public class MovieFieldPattern extends javax.swing.JFrame {

    public boolean add = false, delete = false, edit = false, search = false, update = false;
    private Database d = new Database();

    /**
     * Creates new form bookFieldPattern
     */
    public MovieFieldPattern() {
        initComponents();
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    }

    public MovieFieldPattern(boolean required, Movie... m) {
        initComponents();
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        Validation verify;
        if (required) {
            verify = new Validation(true);
        } else {
            verify = new Validation();
        }
        movieTitle.setInputVerifier(verify);
        director.setInputVerifier(verify);
        year.setInputVerifier(verify);
        try {
            if (m[0].getId() >= 0) {
                fillField(m[0]);
                update = true;
            }
        } catch (ArrayIndexOutOfBoundsException e) {
            //when only one parameter is defined
        }

    }

    public void fillField(Movie m) {
        idValue.setText(Integer.toString(m.getId()));
        movieTitle.setText(m.getName());
        director.setText(m.getDirector());
        year.setText(Integer.toString(m.getYear()));
        Category.setSelectedItem(m.getCategory());
    }

    public void search(Movie m, String... mode) {
        try {
            List<Movie> movies = new LinkedList<>();
            movies = d.selectMovies(m);
            Object[][] data = d.convertToTable(movies);
            String[] columnNames = {
                "ID",
                "Tytuł",
                "Reżyser",
                "Rok",
                "Kategoria"};
            ListResult table = new ListResult(data, columnNames, "movie");
            table.setVisible(true);
            if (mode[0].equals("edit")) {
                table.setEnabledButton("edit");
            }
            if (mode[0].equals("delete")) {
                table.setEnabledButton("delete");
            }
        } catch (IndexOutOfBoundsException e) {
            //nothing to do here  
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        Title = new javax.swing.JLabel();
        movieTitle = new javax.swing.JTextField();
        directorrname = new javax.swing.JLabel();
        director = new javax.swing.JTextField();
        lyear = new javax.swing.JLabel();
        year = new javax.swing.JTextField();
        lcategory = new javax.swing.JLabel();
        Category = new javax.swing.JComboBox<>();
        mainlabel = new javax.swing.JLabel();
        SaveChanges = new javax.swing.JButton();
        idValue = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        Title.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        Title.setText("Tytuł:");

        movieTitle.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

        directorrname.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        directorrname.setText("Reżyser:");

        director.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

        lyear.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        lyear.setText("Rok:");

        year.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

        lcategory.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        lcategory.setText("Kategoria:");

        Category.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { " ", "Akcji", "Anime", "Animowany", "Baśń", "Biograficzny", "Dla dzieci", "Dla młodzieży", "Dokument", "Dokumentalizowany", "Dramat", "Edukacyjny", "Etiuda", "Fabularyzowany dokument", "Familijny", "Fantastyka", "Fantasy", "Historyczny", "Horror", "Karate", "Katastroficzny", "Komedia", "Komedia romantyczna", "Komediodramat", "Kostiumowy", "Kryminał", "Kung-fu", "Melodramat", "Musical", "Obyczajowy", "Parodia", "Przygodowy", "Przyrodniczy", "Psychologiczny", "Religijny", "Romans", "Satyra", "Science fiction", "Sensacja", "Sportowy", "Surrealistyczny", "Sztuki walki", "Thriller", "Western", "Wojenny" }));

        mainlabel.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        mainlabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        mainlabel.setText("Wypełnij formualrz:");

        SaveChanges.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        SaveChanges.setText("OK");
        SaveChanges.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SaveChangesActionPerformed(evt);
            }
        });

        idValue.setText(".");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Title)
                            .addComponent(directorrname)
                            .addComponent(idValue, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(52, 52, 52)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(director, javax.swing.GroupLayout.PREFERRED_SIZE, 219, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(movieTitle, javax.swing.GroupLayout.PREFERRED_SIZE, 362, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(mainlabel, javax.swing.GroupLayout.PREFERRED_SIZE, 289, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(lcategory, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lyear, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE))
                        .addGap(17, 17, 17)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(year, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Category, javax.swing.GroupLayout.PREFERRED_SIZE, 220, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(SaveChanges, javax.swing.GroupLayout.PREFERRED_SIZE, 220, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(21, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(mainlabel)
                    .addComponent(idValue))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Title)
                    .addComponent(movieTitle, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(directorrname)
                    .addComponent(director, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lyear)
                    .addComponent(year, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lcategory)
                    .addComponent(Category, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(33, 33, 33)
                .addComponent(SaveChanges)
                .addContainerGap(26, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public void ChangeOkButtonText(String s) {
        this.SaveChanges.setText(s);
    }

    private void SaveChangesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveChangesActionPerformed
        if (this.add) {
            try {
                Movie m = new Movie(0, movieTitle.getText(), director.getText(), year.getText(), Category.getSelectedItem().toString());
                m.insertToDB();
                this.dispose();
            } catch (SQLException e) {
                e.getMessage();
            }
        } else if (this.edit) {
            Movie m = new Movie(0, movieTitle.getText(), director.getText(), year.getText(), Category.getSelectedItem().toString());
            this.search(m, "edit");
        } else if (this.delete) {
            Movie m = new Movie(0, movieTitle.getText(), director.getText(), year.getText(), Category.getSelectedItem().toString());
            this.search(m, "delete");
        } else if (this.search) {
            Movie m = new Movie(0, movieTitle.getText(), director.getText(), year.getText(), Category.getSelectedItem().toString());
            this.search(m);
        } else if (this.update) {
            Movie m = new Movie(Integer.parseInt(idValue.getText()), movieTitle.getText(), director.getText(), year.getText(), Category.getSelectedItem().toString());
            try {
                m.editInDB();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        d.closeConnection();
        dispose();
    }//GEN-LAST:event_SaveChangesActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MovieFieldPattern.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MovieFieldPattern.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MovieFieldPattern.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MovieFieldPattern.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MovieFieldPattern().setVisible(false);
            }
        });

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> Category;
    private javax.swing.JButton SaveChanges;
    private javax.swing.JLabel Title;
    private javax.swing.JTextField director;
    private javax.swing.JLabel directorrname;
    private javax.swing.JLabel idValue;
    private javax.swing.JLabel lcategory;
    private javax.swing.JLabel lyear;
    private javax.swing.JLabel mainlabel;
    private javax.swing.JTextField movieTitle;
    private javax.swing.JTextField year;
    // End of variables declaration//GEN-END:variables
}
