/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package library;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.InputVerifier;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

/**
 *
 * @author Agnieszka
 */
public class Validation extends InputVerifier {

    public final int nowadays = 2016;
    String expression;
    boolean required = false;
    int year;

    public Validation(boolean rq) {
        required = rq;
    }

    public Validation() {
    }

    @Override
    public boolean verify(JComponent input) {
        return checkField(input);
    }

    public boolean checkField(JComponent input) {
        JTextField tf = (JTextField) input;
        if (required) {
            if ("".equals(tf.getText())) {
                JOptionPane.showMessageDialog(null, "Pole wymagane!", "Błąd wprowadzanych danych", JOptionPane.INFORMATION_MESSAGE);
                return false;
            }
        }
        if (input.getName() != null) {
            if (input.getName().equals("year")) {
                if (!"".equals(tf.getText())) {
                    try {
                        year = Integer.parseInt(tf.getText());
                        if (year > nowadays || year < 1900) {
                            JOptionPane.showMessageDialog(null, "Data spoza zakresu.", "Błąd wprowadzanych danych", JOptionPane.INFORMATION_MESSAGE);
                            return false;
                        }
                    } catch (NumberFormatException e) {
                        JOptionPane.showMessageDialog(null, "Wpisz datę w formacie: YYYY", "Błąd wprowadzanych danych", JOptionPane.INFORMATION_MESSAGE);
                        return false;
                    }
                }
            }
            if (input.getName().equals("isbn")) {
                if (!"".equals(tf.getText())) {
                    Pattern p = Pattern.compile("[0-9][0-9][0-9]-[0-9]-[0-9][0-9][0-9][0-9]-[0-9]");
                    Matcher m = p.matcher(tf.getText());
                    if (m.matches()) {
                        return true;
                    } else {
                        JOptionPane.showMessageDialog(null, "Wpisz ISBN we właściwym formacie", "Sprawdzenie pola:", JOptionPane.INFORMATION_MESSAGE);
                        return false;
                    }
                }
                return true;
            }
        }

        return true;
    }

}
